!
! vdp.s : low level stuff for the video display processor
!

    .sect text
    .sect rom
    .sect data
    .sect bss


	.sect text

	
	! void set_vreg(int reg_num, int value) 
	.define _set_vreg
_set_vreg:
	move.w 4(a7),d0
	move.w 6(a7),d1
	and.w #0x1F,d0
	or.w #0x80,d0
	lsl.w #8,d0
	move.b d1,d0
	lea 0xC00004,a0
	move.w d0,(a0)
	rts
	
	! int get_vstat(void) 
	.define _get_vstat
_get_vstat:
	lea 0xC00004,a0
	move.w (a0),d0
	rts

	! void set_vaddr(int bank, int addr)
	.define _set_vaddr
_set_vaddr:
	move.w 4(a7),a0
	move.w 6(a7),a1
	move.w a1,d0
	and.w #0x3FFF,d0
	move.w a0,d1
	ror.w #2,d1
	and.w #0xC000,d1
	or.w d1,d0
	swap d0
	move.w a1,d0
	rol.w #2,d0
	and.w #3,d0
	move.w a0,d1
	lsl.w #2,d1
	and.w #0x00F0,d1
	or.w d1,d0
	lea 0xC00004,a0
	move.l d0,(a0)
	rts
	
	! void set_vram(int value)
	.define _set_vram
_set_vram:
	move.w 4(a7),d0
	lea 0xC00000,a0
	move.w d0,(a0)
	rts
	
	! void copy_vram(int *from, int size)
	.define _copy_vram
_copy_vram:
	move.l 4(a7),a1
	move.w 8(a7),d0
	lea 0xC00000,a0
	sub.l #1,d0
copyloop:
	move.w (a1)+,(a0)
	dbra d0,copyloop
	rts
	
	! void fill_vram(int value, int size)
	.define _fill_vram
_fill_vram:
	move.w 4(a7),d1
	move.w 6(a7),d0
	lea 0xC00000,a0
	sub.l #1,d0
fillloop:
	move.w d1,(a0)
	dbra d0,fillloop
	rts
	

