
#include "tos.h"


long clocks_per_sec(void)
{
  return 200;
}

long clock_val;

void clock_super(void)
{
  clock_val = *((long *)0x4BA);  /* _hz200 */
}

long clock(void)
{
  Supexec((long)clock_super);
  return clock_val;
}

struct funcs {
  int version;
  long (*clocks_per_sec)(void);
  long (*clock)(void);
  void (*putchar)(int);
  int (*printf)(char *,...);
};

void putchar(int);
int printf(char *,...);

struct funcs f = {
  0x0100,
  clocks_per_sec, 
  clock, 
  putchar,
  printf
};

/* from basepage.h */
typedef struct basep {
  long            p_lowtpa;       /* pointer to self (bottom of TPA) */
  long            p_hitpa;        /* pointer to top of TPA + 1 */
  long            p_tbase;        /* base of text segment */
  long            p_tlen;         /* length of text segment */
  long            p_dbase;        /* base of data segment */
  long            p_dlen;         /* length of data segment */
  long            p_bbase;        /* base of BSS segment */
  long            p_blen;         /* length of BSS segment */
  char            *p_dta;         /* pointer to current DTA */
  struct basep    *p_parent;      /* pointer to parent's basepage */
  long            p_flags;        /* memory usage flags */
  char            *p_env;         /* pointer to environment string */
/* Anything after this (except for p_cmdlin) is undocumented, reserved,
 * subject to change, etc. -- user programs must NOT use!
 */
  char            p_devx[6];      /* real handles of the standard devices */
  char            p_res2;         /* reserved */
  char            p_defdrv;       /* default drv */
  long            p_undef[17];    /* reserved space */
  long            p_usp;          /* a fake USP to make dLibs programs happy */
  char            p_cmdlin[128];  /* command line image */
} BASEPAGE;
/* end of basepage.h */

void putchar(int c)
{
  if(c == '\n') {
    Cconws("\012\015");
  } else {
    Cconout(c);
  }
}


int main()
{
  char *fname = "thing.prz";
  BASEPAGE *basepage;
  void (*go)(struct funcs *);

  /* not reverse, clr home, wrapping */
  printf("\033q\033E\033v");

  printf("running \"%s\".\n", fname);

  basepage = (BASEPAGE *) Pexec(3,fname,0L,0L);
  if(basepage == 0) {
    printf("could not Pexec()\n");
    Pterm(0);
  }
  go = (void (*)()) (basepage->p_tbase);
  go(&f);
  printf("hit any key to quit");
  Cconin();
  Pterm(0);
}








